﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Ribbon;

namespace QATTtest
{
    /// <summary>
    /// Interaction logic for SeparatedMenu.xaml
    /// </summary>
    public partial class SeparatedMenu : MenuTool
		, IRibbonTool
    {
        public SeparatedMenu()
        {
            InitializeComponent();
        }

        private void ButtonTool_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Action 2");
        }

        private void ButtonTool1_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Action 1");
        }

		#region IRibbonTool Members

		Infragistics.Windows.Ribbon.Internal.RibbonToolProxy IRibbonTool.ToolProxy
		{
			get { return SeparatedMenuToolProxy.Instance; }
		}

		#endregion //IRibbonTool

		#region SeparatedMenuToolProxy
		protected class SeparatedMenuToolProxy : MenuToolProxy
		{
			internal static SeparatedMenuToolProxy Instance = new SeparatedMenuToolProxy();

			private SeparatedMenuToolProxy()
			{
			}

			// option 1 - just return a new menutool and not the derived type
			// and let the base implementation of the proxy bind the basic 
			// properties like large|smallimage, caption, isqatcommontool, 
			// visibility, isenabled, datacontext, contextmenu, tooltip, 
			// ischecked, buttontype, command, commandtarget, commandparameter
			protected override MenuToolBase Clone(MenuToolBase sourceTool)
			{
				return new MenuTool();
			}

			// option 2 - use the SeparatedMenu cloned instance but clear the items
			// so the ItemsSource can be bound
			//protected override void Bind(MenuToolBase sourceTool, MenuToolBase targetTool)
			//{
			//    targetTool.ItemsSource = null;
			//    targetTool.Items.Clear();
			//
			//    base.Bind(sourceTool, targetTool);
			//}
		} 
		#endregion //SeparatedMenuToolProxy
	}
}
